%ifndef noImpExitProcess
EXTERN ExitProcess
IMPORT ExitProcess kernel32.dll
%endif

%define MSGhwnd esp+4
%define MSGmsg esp+8
%define MSGwPrm esp+12
%define MSGlPrm esp+16

%define ci user32.dll

%idefine TWORD_size 10
%idefine QWORD_size 8
%idefine DWORD_size 4
%idefine WORD_size 2
%idefine BYTE_size 1

%imacro jfpop 0-1 1
%rep %0
ffree st0
fincstp
%endrep
%endmacro


%ifndef nowin32
%include "win32n.inc"
%endif

%imacro create 2+
[SECTION DATA USE32 CLASS=DATA ALIGN 4]
%ifstr %2
%1:
db %2, 0
%1_size equ $-%1-1
%1_end:
%else
%1:
resb %2_size
%endif
__SECT__
%endmacro

%imacro ei 2
EXTERN %1
IMPORT %1 %2
%endmacro

%imacro pushex 1
%ifstr %1
[SECTION DATA USE32 CLASS=DATA ALIGN 4]
%%str db %1, 0
__SECT__
push DWORD %%str
%else
push DWORD %1
%endif
%endmacro

%imacro pushex 2-*
%rep %0
pushex { %1 }
%rotate 1
%endrep
%endmacro

%imacro popex 2-*
%rep %0
%rotate -1
pop %1
%endrep
%endmacro

%imacro Xcall 2-*
%rep %0-2
%rotate -1
pushex { %1 }
%endrep
%rotate -2
EXTERN %1
IMPORT %1 %2
call [%1]

%endmacro

%imacro XXcall 1-*
EXTERN %1
%rep %0-1
%rotate -1
pushex { %1 }
%endrep
%rotate -1
call %1
%endmacro

%imacro Ecall 1-*

%rep %0-1
%rotate -1
pushex { %1 }
%endrep
%rotate -1
call %1
%endmacro

%imacro Kcall 1-*
ei %1, kernel32.dll
%rep %0-1
%rotate -1
pushex { %1 }
%endrep
%rotate -1
call [%1]
%endmacro

%imacro Ucall 1-*
ei %1, user32.dll
%rep %0-1
%rotate -1
pushex { %1 }
%endrep
%rotate -1
call [%1]
%endmacro

%imacro Gcall 1-*
ei %1, gdi32.dll
%rep %0-1
%rotate -1
pushex { %1 }
%endrep
%rotate -1
call [%1]
%endmacro

%imacro EEcall 1-*
ei %1, ci
%rep %0-1
%rotate -1
pushex { %1 }
%endrep
%rotate -1
call [%1]
%endmacro

%imacro EDDcall 2-*

%rep %0-2
%rotate -1
pushex %1
%endrep
%rotate -2
mov eax, [%1]
mov eax, [eax]
mov eax, [eax+%2]
push dword [%1]
call eax
%endmacro

%ifndef GLOB_MAC
%define GLOB_MAC

%imacro glob 1
GLOBAL %1
%1:
%endmacro

%imacro eglob 1
EXPORT %1
GLOBAL %1
%1:
%endmacro

%endif


;			END OF BASE MACROS




%imacro ERR_Z 0
%%begin
or eax, eax
jz %%noerror
mov edi, %%callbit-%%begin
XXcall Jerror
%%callbit
%%noerror
%endmacro

%imacro ERR_NZ 0
%%begin
or eax, eax
jnz %%noerror
ei GetLastError, kernel32.dll
call [GetLastError]
mov edi, %%callbit-%%begin
XXcall Jerror
%%callbit
%%noerror
%endmacro







;	%1	%2    %3     %4	     %5		   %6			%7	     %8		%9		%10	     %11	%12					%13		%14		    %15
;winhndl addr, Xpos, Ypos, Xwidth, Ywidth, classname "string", wintitle "string", icon hndl, cursor hndl, wndclassexstyle, winproc, filehandle, /*optional begins here*/ menuname "string", createwinex_style, smallcion hndl
;														const	  const
;%16 \/			%17		%18		%19		%20
;createwinex exstyle, parent, createwinex menu, createwinex exdata, bckgrnd_brush
;									const

%macro mkwinmacro 12-20 0,0,0,0,0,0,0,0
EXTERN RegisterClassExA
IMPORT RegisterClassExA user32.dll
EXTERN CreateWindowExA
IMPORT CreateWindowExA user32.dll

[section DATA USE32 CLASS=DATA ALIGN 4]

%%wndclassstruc:
istruc WNDCLASSEX
at WNDCLASSEX.cbSize, dd WNDCLASSEX_size
at WNDCLASSEX.style, dd %10
at WNDCLASSEX.lpfnWndProc, dd %11
at WNDCLASSEX.cbClsExtra, dd 0
at WNDCLASSEX.cbWndExtra, dd 0
at WNDCLASSEX.hInstance, dd 0
at WNDCLASSEX.hIcon, dd 0
at WNDCLASSEX.hCursor, dd 0
at WNDCLASSEX.hbrBackground, dd %20
at WNDCLASSEX.lpszMenuName, dd %%menuname
at WNDCLASSEX.lpszClassName, dd %%classname
at WNDCLASSEX.hIconSm, dd 0
iend

%%menuname
db %13, 0
%%classname
db %6, 0
%%windowname
db %7, 0
__SECT__
%if %8
mov eax, %8
mov [%%wndclassstruc+WNDCLASSEX.hIcon], eax
%endif
%if %9
mov eax, %9
mov [%%wndclassstruc+WNDCLASSEX.hCursor], eax
%endif
mov eax, %12
mov [%%wndclassstruc+WNDCLASSEX.hInstance], eax
%if %15
mov eax, %15
mov [%%wndclassstruc+WNDCLASSEX.hIconSm], eax
%endif
Ecall [RegisterClassExA], %%wndclassstruc
or eax, eax
jz %%endofmacro
Ecall [CreateWindowExA], %16, %%classname, %%windowname, %14, %2, %3, %4, %5, %17, %18, %19
or eax, eax
jz %%endofmacro
mov [%1], eax
xor eax, eax
not eax
%%endofmacro:
%endmacro

%macro mkstdwndproc 0-1
EXTERN DefWindowProcA
IMPORT DefWindowProcA user32.dll
EXTERN PostQuitMessage
IMPORT PostQuitMessage user32.dll

cmp DWORD [esp+8], WM_DESTROY
jz %%killwindow
%if %0=1
%ifstr %1
%include %1
%else
mov DWORD [win_reentry], %%reentry
jmp %1
%%reentry
%endif
%endif

jmp [DefWindowProcA]

%%killwindow:
push DWORD NULL
call [PostQuitMessage]
xor eax, eax

ret 16
%ifndef WINREENTRY
create win_reentry, DWORD
%define WINREENTRY
%endif
%endmacro




%macro mkstdmsgpmp 0-3 0,0,0

EXTERN PeekMessageA
IMPORT PeekMessageA user32.dll
EXTERN GetMessageA
IMPORT GetMessageA user32.dll 
EXTERN DispatchMessageA
IMPORT DispatchMessageA user32.dll

[SECTION DATA USE32 CLASS=DATA ALIGN 4]

%%messagebuffer resd 7

__SECT__

%%MessageLoop:

%ifstr %2 
%include %2
%elifid %1
mov eax, %%messagebuffer
call %2
%endif

%if %1=1
push DWORD NULL
push DWORD NULL
push DWORD NULL
push DWORD NULL
push DWORD %%messagebuffer
call [PeekMessageA]

or eax, eax
jz %%MessageLoop
%endif

push DWORD NULL
push DWORD NULL
push DWORD NULL
push DWORD %%messagebuffer
call [GetMessageA]
or eax, eax
jz %%killallobjects

%ifstr %3
mov eax, %%messagebuffer
%include %3
%elifid %3
mov eax, %%messagebuffer
call %3
%endif

push DWORD %%messagebuffer
call [DispatchMessageA]
jmp %%MessageLoop

%%killallobjects
;user finishes
%endmacro

%define STRUC_SIZE DWORD

%macro movstruc 2
movstruc_ %1, %2, STRUC_NAME
%endmacro

%macro movstruc_ 3
mov STRUC_SIZE [STRUC_OFF+%3.%1], %2
%endmacro

%macro opendialogbox 0
sub esp, OPENFILENAMESTRUCT_size
movstruc lStructSize, OPENFILENAMESTRUCT_size 
movstruc hWndOwner, 0
movstruc hInstance, 0
movstruc lpstrFilter, deffilters
movstruc lpstrCustomFilter, 0
movstruc nMaxCustFilter, 0
movstruc nFilterIndex, 1
movstruc lpstrFile, eax
movstruc nMaxFile, 512
movstruc lpstrFileTitle, 0
movstruc nMaxFileTitle, 0
movstruc lpstrInitialDir, 0
movstruc lpstrTitle, 0
movstruc Flags, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
movstruc Flags+4, 0
movstruc Flags+8, 0
movstruc Flags+12, 0
movstruc Flags+16, 0
movstruc Flags+20, 0
Xcall GetOpenFilenameA, commdlg32.dll, esp
add esp, OPENFILENAMESTRUCT_size
%endmacro



